<template>
    <div>
        <nav class="navbar is-fixed-top" role="navigation" aria-label="main navigation">
            <div class="navbar-brand">
                <nuxt-link :to="localePath('/')" class="navbar-item">
                    <img src="/kmlogo.png" alt="Logo">
                    {{ $t('header.title') }}
                </nuxt-link>

                <a role="button" class="navbar-burger burger" aria-label="menu" aria-expanded="false" data-target="navbar-menu"
                   @click="toggleMenu" :class="{'is-active': menu}">
                    <span aria-hidden="true"></span>
                    <span aria-hidden="true"></span>
                    <span aria-hidden="true"></span>
                </a>
            </div>

            <div id="navbar-menu" class="navbar-menu" :class="{'is-active': menu}" @click="menu = false">
                <nuxt-link :to="localePath('/')" class="navbar-item" :title="$t('header.random')">
                    <font-awesome-icon :icon="['fas', 'dice']" :fixedWidth="true"></font-awesome-icon> {{ $t('header.random') }}
                </nuxt-link>
                <nuxt-link :to="localePath('/search')" class="navbar-item" :title="$t('header.search')">
                    <font-awesome-icon :icon="['fas', 'search']" :fixedWidth="true"></font-awesome-icon> {{ $t('header.search') }}
                </nuxt-link>
                <a href="#" class="navbar-item" @click="suggestion = true" :title="$t('header.add')">
                    <font-awesome-icon :icon="['fas', 'plus']" :fixedWidth="true"></font-awesome-icon> {{ $t('header.add') }}
                </a>
                <div class="navbar-end">
                    <nuxt-link :to="localePath('/about')" class="navbar-item">
                        <font-awesome-icon class="mobile-only" :icon="['fas', 'info']" :fixedWidth="true"></font-awesome-icon>
                        {{ $t('header.about') }}
                    </nuxt-link>
                    <a class="navbar-item" href="https://karaokes.moe/" target="_blank">
                        <font-awesome-icon class="mobile-only" :icon="['fas', 'external-link-alt']" :fixedWidth="true"></font-awesome-icon>
                        {{ $t('header.km') }}
                    </a>
                    <div class="navbar-item has-dropdown is-hoverable">
                        <a aria-haspopup="true" aria-controls="lang-menu" class="navbar-link" @contextmenu="$router.push({path: localePath('/login')})">
                            <font-awesome-icon :icon="['fas', 'language']" :fixedWidth="true"></font-awesome-icon>
                        </a>
                        <div class="navbar-dropdown" id="lang-menu">
                            <nuxt-link
                                class="navbar-item"
                                v-for="locale in availableLocales"
                                :key="locale.code"
                                :to="switchLocalePath(locale.code)">{{ locale.name }}</nuxt-link>
                        </div>
                    </div>
                </div>
            </div>
        </nav>
        <nuxt @suggestion="suggestion = true"/>
        <suggestion-modal v-if="suggestion" @close="suggestion = false"></suggestion-modal>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue';
    // @ts-ignore : Again, WebStorm linter is bugging
    import SuggestionModal from "~/components/SuggestionModal.vue";
    import {NuxtVueI18n} from "nuxt-i18n";
    import LocaleObject = NuxtVueI18n.Options.LocaleObject;

    export default Vue.extend({
        components: {
            SuggestionModal
        },

        data() {
            return {
                menu: false,
                suggestion: false
            }
        },

        methods: {
            toggleMenu() {
                this.menu = !this.menu;
            }
        },

        computed: {
            availableLocales() {
                return this.$i18n.locales?.filter(i => (i as LocaleObject).code !== this.$i18n.locale);
            }
        }
    });
</script>

<style lang="scss">
    @media (min-width: 1024px) {
        .mobile-only {
            display: none;
        }
    }
</style>
